--
-- Author: GtX
-- About: Hides production points from the Production Menu if the 'hiddenOnUI' flag is true
--        Designed for use in maps when hidden production points are required
--

if InGameMenuProductionFrame.HIDE_PRODUCTION_POINTS == nil then
    InGameMenuProductionFrame.HIDE_PRODUCTION_POINTS = true

    local emptyTable = {}

    InGameMenuProductionFrame.getProductionPoints = Utils.overwrittenFunction(InGameMenuProductionFrame.getProductionPoints, function(self, superFunc)
        local totalProductionPoints = superFunc(self) or emptyTable
        local visibleProductionPoints = {}

        for _, productionPoint in ipairs (totalProductionPoints) do
            if not productionPoint.hiddenOnUI then
                table.insert(visibleProductionPoints, productionPoint)
            end
        end

        return visibleProductionPoints
    end)

    -- Remove the menu option from the interaction trigger but still allow purchase
    ProductionPointActivatable.getIsActivatable = Utils.overwrittenFunction(ProductionPointActivatable.getIsActivatable, function(self, superFunc)
        if self.productionPoint.hiddenOnUI and self.productionPoint.isOwned then
            return false
        end

        return superFunc(self)
    end)
end
